#!/usr/bin/env node
import a from "node:path";
import t from "node:fs";
import v from "lodash.get";
import I from "lodash.set";
import e from "chalk";
import { getKey as J, paramsResolve as P } from "./utils/resolve.mjs";
const O = async (g) => {
  const { sourceJsonFilePath: c, injectKeyPath: m, injectInfoFilePath: l } = g, i = process.cwd();
  if (!c.endsWith(".json"))
    return console.log(e.red("源文件必须是json")), process.exit(1);
  if (!l.endsWith(".json"))
    return console.log(e.red("注入文件必须是json")), process.exit(1);
  const p = a.resolve(i, c), d = t.readFileSync(p, "utf-8"), h = JSON.parse(d), r = m.reduce(
    (o, u) => {
      const { key: f, targetKey: y, paramsList: j } = J(u);
      if (!f)
        return console.log(e.red(`注入key不能为空,请检查配置${u}是否正确`)), o;
      const F = v(h, f), S = P({
        valueInit: F,
        paramsList: j
      });
      return I(o, y, S), o;
    },
    {}
  ), n = a.resolve(i, l), s = JSON.stringify(r, null, 2);
  if (t.existsSync(n)) {
    const o = t.readFileSync(n, "utf-8");
    if (s === o)
      return console.log(e.gray("注入文件已存在且内容相同，无需重复注入")), r;
    console.log(e.blue("文件内容变化,开始覆盖注入文件"));
  } else
    console.log(e.green("开始注入文件"));
  return t.writeFileSync(n, s), console.log(
    e.green(`文件注入成功: ${n}`),
    e.blue(s)
  ), r;
};
export {
  O as handler
};
